package cz.moneta.test.regression.backoffice.exevido.web.mailroom;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import org.junit.jupiter.api.AfterEach;

import static cz.moneta.test.dsl.exevido.pages.NewIncomingMessagePage.MESSAGE_ID_KEY;
import static cz.moneta.test.dsl.exevido.pages.NewOutgoingMessagePage.ATTACHMENT_PATH;
import static cz.moneta.test.dsl.util.task.ufo.cb.CommercialTasks.JIRA_COMMENT_STORE_KEY;

@TestScenario(name = "Mark Incoming Message As Resolved")
public class MarkIncomingMessageAsResolved {

    @TestCase(name = "Mark Incoming Message As Resolved")
    @JiraTestCase(id = "BOC-T8501")
    public void markIncomingMessageAsResolved(Harness harness, @Key(Keys.exevido.mailroom) Credentials credentials) {
        harness.withExevido()
                .openLoginPage()
                .then(harness.tasks().exevidoTasks().login().withCredentialsToMmb(credentials))
                .clickIncomingMessages()
                .clickCreateNewIncomingMessage()
                .fillSubject("Automat TEST - vyřízená")
                .fillSender("5nqh2a3 ")
                .fillTypeMessage("Obecná - MMB")
                .uploadAttachment(ATTACHMENT_PATH)
                .fillAssigneeUserGroup("F00102")
                .clickSave()
                .acceptAlertIfVisible()
                .storeMessageId()
                .clickIncomingMessages()
                .clickAllIncomingMessages()
                .searchByMessageId(harness.get(MESSAGE_ID_KEY))
                .clickIncomingMessageRow(30)
                .clickProcessed();
    }

    @AfterEach
    protected void tearDown(Harness harness) {
        harness.store(JIRA_COMMENT_STORE_KEY,
                "\nMessage ID: " + harness.get(MESSAGE_ID_KEY, true));
    }
}